"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenericHttpError = void 0;
var class_schema_1 = require("class-schema");
/**
 *
 */
var HttpError = /** @class */ (function (_super) {
    __extends(HttpError, _super);
    function HttpError(statusCode, name, message, key, data) {
        var _this = _super.call(this, name + " [" + statusCode + "]: " + message) || this;
        _this.statusCode = statusCode;
        _this.name = name;
        _this.message = message;
        _this.key = key;
        _this.data = data;
        return _this;
    }
    HttpError.CODE = -1;
    __decorate([
        class_schema_1.prop(),
        __metadata("design:type", Number)
    ], HttpError.prototype, "statusCode", void 0);
    __decorate([
        class_schema_1.prop(),
        __metadata("design:type", String)
    ], HttpError.prototype, "name", void 0);
    __decorate([
        class_schema_1.prop(),
        __metadata("design:type", String)
    ], HttpError.prototype, "message", void 0);
    __decorate([
        class_schema_1.prop(String, { required: false }),
        __metadata("design:type", String)
    ], HttpError.prototype, "key", void 0);
    __decorate([
        class_schema_1.prop(String, { required: false }),
        __metadata("design:type", Object)
    ], HttpError.prototype, "data", void 0);
    HttpError = __decorate([
        class_schema_1.schema(),
        __metadata("design:paramtypes", [Number, String, String, String, Object])
    ], HttpError);
    return HttpError;
}(Error));
exports.default = HttpError;
/**
 *
 */
var GenericHttpError = /** @class */ (function (_super) {
    __extends(GenericHttpError, _super);
    function GenericHttpError() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return GenericHttpError;
}(HttpError));
exports.GenericHttpError = GenericHttpError;
//# sourceMappingURL=HttpError.js.map